diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/ofdm-phy.cc ns-3.38/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.37/src/wifi/model/non-ht/ofdm-phy.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/ofdm-phy.cc	2023-03-16 20:54:23.860869400 -0700
@@ -87,7 +87,8 @@
        12000000, 18000000, 24000000, 27000000 }},
    { 5, // MHz
      {  1500000,  2250000,  3000000,  4500000,
-        6000000,  9000000, 12000000, 13500000 }}};
+        6000000,  9000000, 12000000, 13500000 }},
+};
 
 // clang-format on
 
@@ -294,12 +295,14 @@
                    Time /* ppduDuration */)
 {
     NS_LOG_FUNCTION(this << psdus << txVector);
-    return Create<OfdmPpdu>(psdus.begin()->second,
-                            txVector,
-                            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                                txVector.GetChannelWidth()),
-                            m_wifiPhy->GetPhyBand(),
-                            ObtainNextUid(txVector));
+    return Create<OfdmPpdu>(
+        psdus.begin()->second,
+        txVector,
+        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
+            txVector.GetChannelWidth()),
+        m_wifiPhy->GetPhyBand(),
+        m_wifiPhy->GetLatestPhyEntity()->ObtainNextUid(
+            txVector)); // use latest PHY entity to handle MU-RTS sent with non-HT rate
 }
 
 PhyEntity::PhyFieldRxStatus
@@ -361,22 +364,36 @@
 }
 
 Ptr<SpectrumValue>
-OfdmPhy::GetTxPowerSpectralDensity(double txPowerW,
-                                   Ptr<const WifiPpdu> /* ppdu */,
-                                   const WifiTxVector& txVector) const
+OfdmPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& txVector = ppdu->GetTxVector();
     uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
     uint16_t channelWidth = txVector.GetChannelWidth();
     NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
     const auto& txMaskRejectionParams = GetTxMaskRejectionParams();
-    Ptr<SpectrumValue> v = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
-        centerFrequency,
-        channelWidth,
-        txPowerW,
-        GetGuardBandwidth(channelWidth),
-        std::get<0>(txMaskRejectionParams),
-        std::get<1>(txMaskRejectionParams),
-        std::get<2>(txMaskRejectionParams));
+    Ptr<SpectrumValue> v;
+    if (txVector.IsNonHtDuplicate())
+    {
+        v = WifiSpectrumValueHelper::CreateDuplicated20MhzTxPowerSpectralDensity(
+            centerFrequency,
+            channelWidth,
+            txPowerW,
+            GetGuardBandwidth(channelWidth),
+            std::get<0>(txMaskRejectionParams),
+            std::get<1>(txMaskRejectionParams),
+            std::get<2>(txMaskRejectionParams));
+    }
+    else
+    {
+        v = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity(
+            centerFrequency,
+            channelWidth,
+            txPowerW,
+            GetGuardBandwidth(channelWidth),
+            std::get<0>(txMaskRejectionParams),
+            std::get<1>(txMaskRejectionParams),
+            std::get<2>(txMaskRejectionParams));
+    }
     return v;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/ofdm-phy.h ns-3.38/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.37/src/wifi/model/non-ht/ofdm-phy.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/ofdm-phy.h	2023-03-16 20:54:23.860869400 -0700
@@ -324,8 +324,7 @@
   protected:
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
     Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
-                                                 Ptr<const WifiPpdu> ppdu,
-                                                 const WifiTxVector& txVector) const override;
+                                                 Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
     uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/ofdm-ppdu.cc ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.cc
--- ns-3.37/src/wifi/model/non-ht/ofdm-ppdu.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.cc	2023-03-16 20:54:23.860869400 -0700
@@ -40,18 +40,34 @@
                    bool instantiateLSig /* = true */)
     : WifiPpdu(psdu, txVector, txCenterFreq, uid),
       m_band(band),
-      m_channelWidth(txVector.GetChannelWidth())
+      m_channelWidth(txVector.IsNonHtDuplicate() ? 20 : txVector.GetChannelWidth())
 {
     NS_LOG_FUNCTION(this << psdu << txVector << txCenterFreq << band << uid);
     if (instantiateLSig)
     {
-        m_lSig.SetRate(txVector.GetMode().GetDataRate(txVector), m_channelWidth);
-        m_lSig.SetLength(psdu->GetSize());
+        SetPhyHeaders(txVector, psdu->GetSize());
     }
 }
 
-OfdmPpdu::~OfdmPpdu()
+void
+OfdmPpdu::SetPhyHeaders(const WifiTxVector& txVector, std::size_t psduSize)
 {
+    NS_LOG_FUNCTION(this << txVector << psduSize);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    SetLSigHeader(lSig, txVector, psduSize);
+    m_phyHeaders->AddHeader(lSig);
+#else
+    SetLSigHeader(m_lSig, txVector, psduSize);
+#endif
+}
+
+void
+OfdmPpdu::SetLSigHeader(LSigHeader& lSig, const WifiTxVector& txVector, std::size_t psduSize) const
+{
+    lSig.SetRate(txVector.GetMode().GetDataRate(txVector), m_channelWidth);
+    lSig.SetLength(psduSize);
 }
 
 WifiTxVector
@@ -59,26 +75,50 @@
 {
     WifiTxVector txVector;
     txVector.SetPreambleType(m_preamble);
-    // OFDM uses 20 MHz, unless PHY channel width is 5 MHz or 10 MHz
-    uint16_t channelWidth = m_channelWidth < 20 ? m_channelWidth : 20;
-    txVector.SetMode(OfdmPhy::GetOfdmRate(m_lSig.GetRate(m_channelWidth), channelWidth));
-    txVector.SetChannelWidth(channelWidth);
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    if (m_phyHeaders->PeekHeader(lSig) == 0)
+    {
+        NS_FATAL_ERROR("Missing L-SIG in PPDU");
+    }
+
+    SetTxVectorFromLSigHeader(txVector, lSig);
+#else
+    SetTxVectorFromLSigHeader(txVector, m_lSig);
+#endif
+
     return txVector;
 }
 
+void
+OfdmPpdu::SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const
+{
+    NS_ASSERT(m_channelWidth <= 20);
+    // OFDM uses 20 MHz, unless PHY channel width is 5 MHz or 10 MHz
+    txVector.SetMode(OfdmPhy::GetOfdmRate(lSig.GetRate(m_channelWidth), m_channelWidth));
+    txVector.SetChannelWidth(m_channelWidth);
+}
+
 Time
 OfdmPpdu::GetTxDuration() const
 {
-    Time ppduDuration = Seconds(0);
     const WifiTxVector& txVector = GetTxVector();
-    ppduDuration = WifiPhy::CalculateTxDuration(m_lSig.GetLength(), txVector, m_band);
-    return ppduDuration;
+    uint16_t length = 0;
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader lSig;
+    m_phyHeaders->PeekHeader(lSig);
+    length = lSig.GetLength();
+#else
+    length = m_lSig.GetLength();
+#endif
+    return WifiPhy::CalculateTxDuration(length, txVector, m_band);
 }
 
 Ptr<WifiPpdu>
 OfdmPpdu::Copy() const
 {
-    return Create<OfdmPpdu>(GetPsdu(), GetTxVector(), m_txCenterFreq, m_band, m_uid);
+    return Ptr<WifiPpdu>(new OfdmPpdu(*this), false);
 }
 
 OfdmPpdu::LSigHeader::LSigHeader()
@@ -87,10 +127,6 @@
 {
 }
 
-OfdmPpdu::LSigHeader::~LSigHeader()
-{
-}
-
 TypeId
 OfdmPpdu::LSigHeader::GetTypeId()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/non-ht/ofdm-ppdu.h ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.h
--- ns-3.37/src/wifi/model/non-ht/ofdm-ppdu.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/non-ht/ofdm-ppdu.h	2023-03-16 20:54:23.860869400 -0700
@@ -55,7 +55,6 @@
     {
       public:
         LSigHeader();
-        ~LSigHeader() override;
 
         /**
          * \brief Get the type ID.
@@ -118,22 +117,47 @@
              WifiPhyBand band,
              uint64_t uid,
              bool instantiateLSig = true);
-    /**
-     * Destructor for OfdmPpdu.
-     */
-    ~OfdmPpdu() override;
 
     Time GetTxDuration() const override;
     Ptr<WifiPpdu> Copy() const override;
 
   protected:
-    WifiPhyBand m_band;      //!< the WifiPhyBand used to transmit that PPDU
-    uint16_t m_channelWidth; //!< the channel width used to transmit that PPDU in MHz
-    LSigHeader m_lSig;       //!< the L-SIG PHY header
+    WifiPhyBand m_band; //!< the WifiPhyBand used to transmit that PPDU
+#ifndef NS3_BUILD_PROFILE_DEBUG
+    LSigHeader m_lSig; //!< the L-SIG PHY header
+#endif
 
   private:
     WifiTxVector DoGetTxVector() const override;
-}; // class OfdmPpdu
+
+    /**
+     * Fill in the PHY headers.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param psduSize the size duration of the PHY payload (PSDU)
+     */
+    void SetPhyHeaders(const WifiTxVector& txVector, std::size_t psduSize);
+
+    /**
+     * Fill in the L-SIG header.
+     *
+     * \param lSig the L-SIG header to fill in
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param psduSize the size duration of the PHY payload (PSDU)
+     */
+    void SetLSigHeader(LSigHeader& lSig, const WifiTxVector& txVector, std::size_t psduSize) const;
+
+    /**
+     * Fill in the TXVECTOR from L-SIG header.
+     *
+     * \param txVector the TXVECTOR to fill in
+     * \param lSig the L-SIG header
+     */
+    virtual void SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const;
+
+    uint16_t m_channelWidth; //!< the channel width used to transmit that PPDU in MHz (needed to
+                             //!< distinguish 5 MHz, 10 MHz or 20 MHz PPDUs)
+};                           // class OfdmPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/phy-entity.cc ns-3.38/src/wifi/model/phy-entity.cc
--- ns-3.37/src/wifi/model/phy-entity.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/phy-entity.cc	2023-03-16 20:54:23.860869400 -0700
@@ -239,11 +239,9 @@
 }
 
 Ptr<WifiPpdu>
-PhyEntity::BuildPpdu(const WifiConstPsduMap& psdus,
-                     const WifiTxVector& txVector,
-                     Time /* ppduDuration */)
+PhyEntity::BuildPpdu(const WifiConstPsduMap& psdus, const WifiTxVector& txVector, Time ppduDuration)
 {
-    NS_LOG_FUNCTION(this << psdus << txVector);
+    NS_LOG_FUNCTION(this << psdus << txVector << ppduDuration);
     NS_FATAL_ERROR("This method is unsupported for the base PhyEntity class. Use the overloaded "
                    "version in the amendment-specific subclasses instead!");
     return Create<WifiPpdu>(psdus.begin()->second,
@@ -410,7 +408,9 @@
            const std::pair<WifiSpectrumBand, double>& p2) { return p1.second < p2.second; });
     NS_LOG_FUNCTION(this << ppdu << it->second);
 
-    Ptr<Event> event = DoGetEvent(ppdu, rxPowersW);
+    Ptr<Event> event = m_wifiPhy->GetPhyEntityForPpdu(ppdu)->DoGetEvent(
+        ppdu,
+        rxPowersW); // use latest PHY entity to handle MU-RTS sent with non-HT rate
     if (!event)
     {
         // PPDU should be simply considered as interference (once it has been accounted for in
@@ -1279,30 +1279,31 @@
 }
 
 void
-PhyEntity::StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector)
+PhyEntity::StartTx(Ptr<const WifiPpdu> ppdu)
 {
-    NS_LOG_FUNCTION(this << ppdu << txVector);
-    Transmit(ppdu->GetTxDuration(), ppdu, txVector, "transmission");
+    NS_LOG_FUNCTION(this << ppdu);
+    auto txPowerDbm = m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain();
+    auto txVector = ppdu->GetTxVector();
+    auto txPowerSpectrum = GetTxPowerSpectralDensity(DbmToW(txPowerDbm), ppdu);
+    Transmit(ppdu->GetTxDuration(), ppdu, txPowerDbm, txPowerSpectrum, "transmission");
 }
 
 void
 PhyEntity::Transmit(Time txDuration,
                     Ptr<const WifiPpdu> ppdu,
-                    const WifiTxVector& txVector,
-                    std::string type)
-{
-    NS_LOG_FUNCTION(this << txDuration << ppdu << txVector << type);
-    double txPowerWatts =
-        DbmToW(m_wifiPhy->GetTxPowerForTransmission(ppdu) + m_wifiPhy->GetTxGain());
-    NS_LOG_DEBUG("Start " << type << ": signal power before antenna gain=" << WToDbm(txPowerWatts)
-                          << "dBm");
-    Ptr<SpectrumValue> txPowerSpectrum = GetTxPowerSpectralDensity(txPowerWatts, ppdu, txVector);
-    Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters>();
+                    double txPowerDbm,
+                    Ptr<SpectrumValue> txPowerSpectrum,
+                    const std::string& type)
+{
+    NS_LOG_FUNCTION(this << txDuration << ppdu << txPowerDbm << type);
+    NS_LOG_DEBUG("Start " << type << ": signal power before antenna gain=" << txPowerDbm << "dBm");
+    auto txParams = Create<WifiSpectrumSignalParameters>();
     txParams->duration = txDuration;
     txParams->psd = txPowerSpectrum;
     txParams->ppdu = ppdu;
-    txParams->txCenterFreq = GetCenterFrequencyForChannelWidth(txVector);
-    NS_LOG_DEBUG("Starting " << type << " with power " << WToDbm(txPowerWatts) << " dBm on channel "
+    txParams->txWidth = ppdu->GetTxVector().GetChannelWidth();
+    ;
+    NS_LOG_DEBUG("Starting " << type << " with power " << txPowerDbm << " dBm on channel "
                              << +m_wifiPhy->GetChannelNumber() << " for "
                              << txParams->duration.As(Time::MS));
     NS_LOG_DEBUG("Starting " << type << " with integrated spectrum power "
@@ -1335,4 +1336,34 @@
     return WifiPhy::CalculateTxDuration(it->second->GetSize(), txVector, band, it->first);
 }
 
+bool
+PhyEntity::CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const
+{
+    // The PHY shall not issue a PHY-RXSTART.indication primitive in response to a PPDU that does
+    // not overlap the primary channel
+    const auto channelWidth = m_wifiPhy->GetChannelWidth();
+    const auto primaryWidth =
+        ((channelWidth % 20 == 0) ? 20
+                                  : channelWidth); // if the channel width is a multiple of 20 MHz,
+                                                   // then we consider the primary20 channel
+    const auto p20CenterFreq =
+        m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(primaryWidth);
+    const auto p20MinFreq = p20CenterFreq - (primaryWidth / 2);
+    const auto p20MaxFreq = p20CenterFreq + (primaryWidth / 2);
+    const auto txCenterFreq = ppdu->GetTxCenterFreq();
+    const auto minTxFreq = txCenterFreq - txChannelWidth / 2;
+    const auto maxTxFreq = txCenterFreq + txChannelWidth / 2;
+    if (p20MinFreq < minTxFreq || p20MaxFreq > maxTxFreq)
+    {
+        return false;
+    }
+    return true;
+}
+
+Ptr<const WifiPpdu>
+PhyEntity::GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu)
+{
+    return ppdu;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/phy-entity.h ns-3.38/src/wifi/model/phy-entity.h
--- ns-3.37/src/wifi/model/phy-entity.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/phy-entity.h	2023-03-16 20:54:23.860869400 -0700
@@ -454,6 +454,17 @@
     virtual uint16_t GetStaId(const Ptr<const WifiPpdu> ppdu) const;
 
     /**
+     * Determine whether the PHY shall issue a PHY-RXSTART.indication primitive in response to a
+     * given PPDU.
+     *
+     * \param ppdu the PPDU
+     * \param txChannelWidth the channel width (MHz) used to transmit the PPDU
+     * \return true if the PHY shall issue a PHY-RXSTART.indication primitive in response to a PPDU,
+     * false otherwise
+     */
+    virtual bool CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const;
+
+    /**
      * Check if PHY state should move to CCA busy state based on current
      * state of interference tracker.
      *
@@ -476,9 +487,8 @@
      * \see SpectrumWifiPhy::StartTx
      *
      * \param ppdu the PPDU to send
-     * \param txVector the TXVECTOR used for the transmission of the PPDU
      */
-    virtual void StartTx(Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector);
+    virtual void StartTx(Ptr<const WifiPpdu> ppdu);
 
     /**
      * This function prepares most of the WifiSpectrumSignalParameters
@@ -487,13 +497,15 @@
      *
      * \param txDuration the duration of the transmission
      * \param ppdu the PPDU to send
-     * \param txVector the TXVECTOR used for the transmission of the PPDU
+     * \param txPowerDbm the total TX power in dBm
+     * \param txPowerSpectrum the TX PSD
      * \param type the type of transmission (for logging)
      */
     void Transmit(Time txDuration,
                   Ptr<const WifiPpdu> ppdu,
-                  const WifiTxVector& txVector,
-                  std::string type);
+                  double txPowerDbm,
+                  Ptr<SpectrumValue> txPowerSpectrum,
+                  const std::string& type);
 
     /**
      * \param psduMap the PSDU(s) to transmit indexed by STA-ID
@@ -516,6 +528,26 @@
     virtual double GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
                                    WifiChannelListType channelType) const;
 
+    /**
+     * The WifiPpdu from the TX PHY is received by each RX PHY attached to the same channel.
+     * By default and for performance reasons, all RX PHYs will work on the same WifiPpdu instance
+     * from TX instead of a copy of it. Child classes can change that behavior and do a copy and/or
+     * change the content of the parameters stored in WifiPpdu.
+     *
+     * \param ppdu the WifiPpdu transmitted by the TX PHY
+     * \return the WifiPpdu to be used by the RX PHY
+     */
+    virtual Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu);
+
+    /**
+     * Obtain the next UID for the PPDU to transmit.
+     * Note that the global UID counter could be incremented.
+     *
+     * \param txVector the transmission parameters
+     * \return the UID to use for the PPDU to transmit
+     */
+    virtual uint64_t ObtainNextUid(const WifiTxVector& txVector);
+
   protected:
     /**
      * A map of PPDU field elements per preamble type.
@@ -709,7 +741,7 @@
                                     uint16_t staId,
                                     const std::vector<bool>& statusPerMpdu);
     /**
-     * Perform amendment-specific actions when the payload is unsuccessfully received.
+     * Perform amendment-specific actions when the payload is unsuccessfuly received.
      *
      * \param psdu the PSDU that we failed to received
      * \param snr the SNR of the received PSDU in linear scale
@@ -818,26 +850,15 @@
     void NotifyInterferenceRxEndAndClear(bool reset);
 
     /**
-     * Obtain the next UID for the PPDU to transmit.
-     * Note that the global UID counter could be incremented.
-     *
-     * \param txVector the transmission parameters
-     * \return the UID to use for the PPDU to transmit
-     */
-    virtual uint64_t ObtainNextUid(const WifiTxVector& txVector);
-
-    /**
      * \param txPowerW power in W to spread across the bands
      * \param ppdu the PPDU that will be transmitted
-     * \param txVector the transmission parameters
      * \return Pointer to SpectrumValue
      *
      * This is a helper function to create the right TX PSD corresponding
      * to the amendment of this PHY.
      */
     virtual Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
-                                                         Ptr<const WifiPpdu> ppdu,
-                                                         const WifiTxVector& txVector) const = 0;
+                                                         Ptr<const WifiPpdu> ppdu) const = 0;
 
     /**
      * Get the center frequency of the channel corresponding the current TxVector rather than
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-frame-exchange-manager.cc ns-3.38/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/qos-frame-exchange-manager.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-frame-exchange-manager.cc	2023-03-16 20:54:23.860869400 -0700
@@ -280,6 +280,7 @@
         return false;
     }
 
+    mpdu = CreateAliasIfNeeded(mpdu);
     WifiTxParameters txParams;
     txParams.m_txVector =
         GetWifiRemoteStationManager()->GetDataTxVector(mpdu->GetHeader(), m_allowedWidth);
@@ -312,6 +313,12 @@
     return true;
 }
 
+Ptr<WifiMpdu>
+QosFrameExchangeManager::CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const
+{
+    return mpdu;
+}
+
 bool
 QosFrameExchangeManager::TryAddMpdu(Ptr<const WifiMpdu> mpdu,
                                     WifiTxParameters& txParams,
@@ -637,8 +644,6 @@
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
-    SetTxopHolder(psdu, txVector);
-
     // APs store buffer size report of associated stations
     if (m_mac->GetTypeOfStation() == AP && psdu->GetAddr1() == m_self)
     {
@@ -651,34 +656,71 @@
                 NS_LOG_DEBUG("Station " << hdr.GetAddr2() << " reported a buffer status of "
                                         << +hdr.GetQosQueueSize()
                                         << " for tid=" << +hdr.GetQosTid());
-                StaticCast<ApWifiMac>(m_mac)->SetBufferStatus(hdr.GetQosTid(),
-                                                              hdr.GetAddr2(),
-                                                              hdr.GetQosQueueSize());
+                StaticCast<ApWifiMac>(m_mac)->SetBufferStatus(
+                    hdr.GetQosTid(),
+                    mpdu->GetOriginal()->GetHeader().GetAddr2(),
+                    hdr.GetQosQueueSize());
             }
         }
     }
 
+    // before updating the NAV, check if the NAV counted down to zero. In such a
+    // case, clear the saved TXOP holder address.
+    ClearTxopHolderIfNeeded();
+
     FrameExchangeManager::PreProcessFrame(psdu, txVector);
 }
 
 void
+QosFrameExchangeManager::PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector);
+
+    SetTxopHolder(psdu, txVector);
+    FrameExchangeManager::PostProcessFrame(psdu, txVector);
+}
+
+void
 QosFrameExchangeManager::SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
     const WifiMacHeader& hdr = psdu->GetHeader(0);
 
-    if (hdr.IsQosData() || hdr.IsMgt() || hdr.IsRts())
+    // A STA shall save the TXOP holder address for the BSS in which it is associated.
+    // The TXOP holder address is the MAC address from the Address 2 field of the frame
+    // that initiated a frame exchange sequence, except if this is a CTS frame, in which
+    // case the TXOP holder address is the Address 1 field. (Sec. 10.23.2.4 of 802.11-2020)
+    if ((hdr.IsQosData() || hdr.IsMgt() || hdr.IsRts()) &&
+        (hdr.GetAddr1() == m_bssid || hdr.GetAddr2() == m_bssid))
     {
         m_txopHolder = psdu->GetAddr2();
     }
-    else if (hdr.IsCts() || hdr.IsAck())
+    else if (hdr.IsCts() && hdr.GetAddr1() == m_bssid)
     {
         m_txopHolder = psdu->GetAddr1();
     }
 }
 
 void
+QosFrameExchangeManager::ClearTxopHolderIfNeeded()
+{
+    NS_LOG_FUNCTION(this);
+    if (m_navEnd <= Simulator::Now())
+    {
+        m_txopHolder.reset();
+    }
+}
+
+void
+QosFrameExchangeManager::NavResetTimeout()
+{
+    NS_LOG_FUNCTION(this);
+    FrameExchangeManager::NavResetTimeout();
+    ClearTxopHolderIfNeeded();
+}
+
+void
 QosFrameExchangeManager::ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                                      RxSignalInfo rxSignalInfo,
                                      const WifiTxVector& txVector,
@@ -706,7 +748,7 @@
         // frame matches the saved TXOP holder address, then the STA shall send the
         // CTS frame after SIFS, without regard for, and without resetting, its NAV.
         // (sec. 10.22.2.4 of 802.11-2016)
-        if (hdr.GetAddr2() == m_txopHolder || m_navEnd <= Simulator::Now())
+        if (hdr.GetAddr2() == m_txopHolder || VirtualCsMediumIdle())
         {
             NS_LOG_DEBUG("Received RTS from=" << hdr.GetAddr2() << ", schedule CTS");
             Simulator::Schedule(m_phy->GetSifs(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/qos-frame-exchange-manager.h ns-3.38/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.37/src/wifi/model/qos-frame-exchange-manager.h	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/qos-frame-exchange-manager.h	2023-03-16 20:54:23.860869400 -0700
@@ -22,6 +22,8 @@
 
 #include "frame-exchange-manager.h"
 
+#include <optional>
+
 namespace ns3
 {
 
@@ -92,6 +94,16 @@
                                            const WifiTxParameters& txParams,
                                            Time ppduDurationLimit) const;
 
+    /**
+     * Create an alias of the given MPDU for transmission by this Frame Exchange Manager.
+     * This is required by 11be MLDs to support translation of MAC addresses. For single
+     * link devices, the given MPDU is simply returned.
+     *
+     * \param mpdu the given MPDU
+     * \return the alias of the given MPDU for transmission on this link
+     */
+    virtual Ptr<WifiMpdu> CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const;
+
   protected:
     void DoDispose() override;
 
@@ -100,6 +112,8 @@
                      const WifiTxVector& txVector,
                      bool inAmpdu) override;
     void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
+    void NavResetTimeout() override;
     Time GetFrameDurationId(const WifiMacHeader& header,
                             uint32_t size,
                             const WifiTxParameters& txParams,
@@ -163,10 +177,15 @@
      */
     virtual void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
-    Ptr<QosTxop> m_edca;       //!< the EDCAF that gained channel access
-    Mac48Address m_txopHolder; //!< MAC address of the TXOP holder
-    bool m_setQosQueueSize;    /**< whether to set the Queue Size subfield of the
-                                    QoS Control field of QoS data frames */
+    /**
+     * Clear the TXOP holder if the NAV counted down to zero (includes the case of NAV reset).
+     */
+    virtual void ClearTxopHolderIfNeeded();
+
+    Ptr<QosTxop> m_edca;                      //!< the EDCAF that gained channel access
+    std::optional<Mac48Address> m_txopHolder; //!< MAC address of the TXOP holder
+    bool m_setQosQueueSize;                   /**< whether to set the Queue Size subfield of the
+                                                   QoS Control field of QoS data frames */
 
   private:
     /**
